//-----------　以下のコードは必要のあるユーザのみ記述する --------------

// もしMain()の開始前に実行しておきたいコードが別にある場合は以下に記述．
// このルーチンの出力はログファイルに記録されません．
void preMain() {
  ELROS.World.ReCalc();
}

// もしMain()終了後に実行しておきたいコードが別にある場合は以下に記述．
// このルーチンの出力はログファイルに記録されません．
void postMain() {
// 例) crowbar.clrscr();
  crowbar.clrscr();
  ELROS.World.ReCalc();
  ELROS.Robot.ReCalc();
  mainPaintBoxRefresh();
}

// ユーザ独自のmousePressed()
void userMousePressed() {
  mainPaintBoxMouseDown(mouseX, mouseY);
}
// ユーザ独自のmouseRelased()
void userMouseReleased() {
}
// ユーザ独自のmouseDragged()
void userMouseDragged() {
}
// ユーザ独自のmouseMoved()
void userMouseMoved() {
}
// ユーザ独自のmouseClicked()
void userMouseClicked() {
}
// ユーザ独自のkeyPressed()
void userKeyPressed() {
// 例） if ((key == 'h') || (key == 'H')) crowbar.stop();
  if ((key == 'h') || (key == 'H')) crowbar.stop();
  if ((key == 'q') || (key == 'Q')) crowbar.halt();
  FormKeyDown();
}
// ユーザ独自のkeyRleased()
void userKeyReleased() {
}
// ユーザ独自のkeyTyped()
void userKyeTyped() {
}

// もしMain()終了後に通常のProcessingのようにエンドレスに処理を続ける場合は
// setup()にcrowbar.nonStop()を記述すると共に，以下にコードを記述．
// ユーザ独自のdraw()
void userDraw() {
// 例）  crowbar.writeln("実行中");
  if (ELROS != null) {
    if (ELROS.Sim.SimulationRunning) {
      ELROS.Sim.SetRedrawTiming();
      ELROS.PositionControl_NonCP(false);
    }
    if (ELROS.PGover != null) {
        mainPaintBoxRefresh();
    }
  }
}

void pD2T(D2T p) {
  print(p.x);
  print(":");
  println(p.y);
}
